using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using angGoGo.PhotoController;

namespace PhotoControllerDemo
{

	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		#region Main form components
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.ToolBar toolBar;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.ToolBarButton tbOpen;
		private System.Windows.Forms.ImageList imgList;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.ToolBarButton tbSave;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private System.Windows.Forms.ToolBarButton tbCrop;
		private System.Windows.Forms.ToolBarButton tbResize;
		private System.Windows.Forms.ToolBarButton tbRotate;
		private System.Windows.Forms.ToolBarButton tbFlip;
		private System.Windows.Forms.Panel palMain;
		public System.Windows.Forms.PictureBox pic;
		private System.Windows.Forms.StatusBarPanel statusPalAddon;
		private System.Windows.Forms.StatusBarPanel statusPalCurrent;
		private System.Windows.Forms.OpenFileDialog dlgFile;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem mnuOpen;
		private System.Windows.Forms.MenuItem mnuSave;
		private System.Windows.Forms.MenuItem mnuExit;
		private System.Windows.Forms.MenuItem mnuResize;
		private System.Windows.Forms.MenuItem mnuRotate;
		private System.Windows.Forms.MenuItem mnuFlip;
		private System.Windows.Forms.MenuItem mnuCrop;
		private System.Windows.Forms.MenuItem mnuAdjust;
		private System.Windows.Forms.MenuItem mnuAbout;
		private System.Windows.Forms.MenuItem mnuReset;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.ToolBarButton tbReset;

		private System.Windows.Forms.SaveFileDialog dlgSave;
		private System.Windows.Forms.ToolBarButton tbColorAdjust;
		private System.Windows.Forms.ToolBarButton toolBarButton3;
		private System.Windows.Forms.ColorDialog dlgColor;
		private System.Windows.Forms.ToolBarButton toolBarButton4;
		private Rectangle rectBox;
		private System.Windows.Forms.MenuItem mnuTransparent;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem mnuGray;
		private System.Windows.Forms.MenuItem mnuInvert;
		private System.Windows.Forms.MenuItem mnuBright;
		private System.Windows.Forms.MenuItem mnuContrast;
		private System.Windows.Forms.MenuItem mnuGamma;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem mnuSmooth;
		private System.Windows.Forms.MenuItem mnuBlur;
		private System.Windows.Forms.MenuItem mnuEmboss;
		private System.Windows.Forms.MenuItem mnuEngrave;
		private System.Windows.Forms.MenuItem mnuMosaicNormal;
		private System.Windows.Forms.MenuItem mnuMosaicGrid;
		private System.Windows.Forms.MenuItem mnuSettings;
		private System.Windows.Forms.MenuItem mnuBackgroundColor;
		private System.Windows.Forms.MenuItem mnuBlackWhite;
		private System.Windows.Forms.MenuItem mnuSepia;
		private System.Windows.Forms.MenuItem mnuMeanRemoval;
		private System.Windows.Forms.MenuItem mnuSharpen;
		private System.Windows.Forms.MenuItem mnuEdgeDetection;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem mnuEDSobel;
		private System.Windows.Forms.MenuItem mnuEDPrewiit;
		private System.Windows.Forms.MenuItem mnuEDKirsh;
		private System.Windows.Forms.MenuItem EDHorizontal;
		private System.Windows.Forms.MenuItem mnuEDVertical;
		private System.Windows.Forms.MenuItem mnuEDDifference;
		private System.Windows.Forms.MenuItem mnuEDEnhance;
		private System.Windows.Forms.MenuItem mnuEDHomogenity;
		private System.Windows.Forms.MenuItem mnuBlurGroup;
		private System.Windows.Forms.MenuItem mnuSharpenGroup;
		private System.Windows.Forms.MenuItem mnuStylizeGroup;
		private System.Windows.Forms.MenuItem mnuDiffuse;
		private System.Windows.Forms.MenuItem mnuDistortGroup;
		private System.Windows.Forms.MenuItem mnuDither;
		private System.Windows.Forms.MenuItem mnuCanvas;
		private System.Windows.Forms.MenuItem mnuDitherVertical;
		private System.Windows.Forms.MenuItem mnuGlassBorder;
		private System.Windows.Forms.MenuItem mnuWater;
		private System.Windows.Forms.MenuItem mnuGrey;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem mnuSaveGif;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem mnuFeather;
		private System.Windows.Forms.MenuItem mnuSetBorder;
		#endregion

		//local variables
		private bool Modified=false;	// if the picture is modified, it will be true
		public string FileName="";		// stores the picture's file name
		private bool bBlocking=false;	// marks the mouse is pressed down on the pic
		private Point ptBeg,ptEnd;
		private System.Windows.Forms.MenuItem mnuFeather1;
		private System.Windows.Forms.MenuItem mnuFeather3;
		private System.Windows.Forms.MenuItem mnuFeather2;
		private System.Windows.Forms.MenuItem menuScale;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem12;		// marks the mouse start points and end points

		#region Windows form functions
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuOpen = new System.Windows.Forms.MenuItem();
			this.mnuSave = new System.Windows.Forms.MenuItem();
			this.mnuSaveGif = new System.Windows.Forms.MenuItem();
			this.mnuSettings = new System.Windows.Forms.MenuItem();
			this.mnuBackgroundColor = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.mnuExit = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.mnuReset = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.mnuResize = new System.Windows.Forms.MenuItem();
			this.mnuRotate = new System.Windows.Forms.MenuItem();
			this.mnuFlip = new System.Windows.Forms.MenuItem();
			this.mnuCrop = new System.Windows.Forms.MenuItem();
			this.mnuCanvas = new System.Windows.Forms.MenuItem();
			this.menuScale = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.mnuAdjust = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.mnuTransparent = new System.Windows.Forms.MenuItem();
			this.mnuGray = new System.Windows.Forms.MenuItem();
			this.mnuGrey = new System.Windows.Forms.MenuItem();
			this.mnuInvert = new System.Windows.Forms.MenuItem();
			this.mnuSepia = new System.Windows.Forms.MenuItem();
			this.mnuBlackWhite = new System.Windows.Forms.MenuItem();
			this.mnuBright = new System.Windows.Forms.MenuItem();
			this.mnuContrast = new System.Windows.Forms.MenuItem();
			this.mnuGamma = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.mnuBlurGroup = new System.Windows.Forms.MenuItem();
			this.mnuBlur = new System.Windows.Forms.MenuItem();
			this.mnuSmooth = new System.Windows.Forms.MenuItem();
			this.mnuSharpenGroup = new System.Windows.Forms.MenuItem();
			this.mnuSharpen = new System.Windows.Forms.MenuItem();
			this.mnuMeanRemoval = new System.Windows.Forms.MenuItem();
			this.mnuDistortGroup = new System.Windows.Forms.MenuItem();
			this.mnuDiffuse = new System.Windows.Forms.MenuItem();
			this.mnuDither = new System.Windows.Forms.MenuItem();
			this.mnuDitherVertical = new System.Windows.Forms.MenuItem();
			this.mnuStylizeGroup = new System.Windows.Forms.MenuItem();
			this.mnuEmboss = new System.Windows.Forms.MenuItem();
			this.mnuEngrave = new System.Windows.Forms.MenuItem();
			this.mnuGlassBorder = new System.Windows.Forms.MenuItem();
			this.mnuWater = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.mnuEDSobel = new System.Windows.Forms.MenuItem();
			this.mnuEDPrewiit = new System.Windows.Forms.MenuItem();
			this.mnuEDKirsh = new System.Windows.Forms.MenuItem();
			this.EDHorizontal = new System.Windows.Forms.MenuItem();
			this.mnuEDVertical = new System.Windows.Forms.MenuItem();
			this.mnuEDDifference = new System.Windows.Forms.MenuItem();
			this.mnuEDHomogenity = new System.Windows.Forms.MenuItem();
			this.mnuEDEnhance = new System.Windows.Forms.MenuItem();
			this.mnuEdgeDetection = new System.Windows.Forms.MenuItem();
			this.mnuMosaicNormal = new System.Windows.Forms.MenuItem();
			this.mnuMosaicGrid = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.mnuFeather = new System.Windows.Forms.MenuItem();
			this.mnuFeather1 = new System.Windows.Forms.MenuItem();
			this.mnuFeather2 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.mnuFeather3 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.mnuSetBorder = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.mnuAbout = new System.Windows.Forms.MenuItem();
			this.toolBar = new System.Windows.Forms.ToolBar();
			this.tbOpen = new System.Windows.Forms.ToolBarButton();
			this.tbSave = new System.Windows.Forms.ToolBarButton();
			this.tbReset = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.tbCrop = new System.Windows.Forms.ToolBarButton();
			this.tbResize = new System.Windows.Forms.ToolBarButton();
			this.tbRotate = new System.Windows.Forms.ToolBarButton();
			this.tbFlip = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
			this.tbColorAdjust = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton4 = new System.Windows.Forms.ToolBarButton();
			this.imgList = new System.Windows.Forms.ImageList(this.components);
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.statusPalAddon = new System.Windows.Forms.StatusBarPanel();
			this.statusPalCurrent = new System.Windows.Forms.StatusBarPanel();
			this.palMain = new System.Windows.Forms.Panel();
			this.pic = new System.Windows.Forms.PictureBox();
			this.dlgFile = new System.Windows.Forms.OpenFileDialog();
			this.dlgSave = new System.Windows.Forms.SaveFileDialog();
			this.dlgColor = new System.Windows.Forms.ColorDialog();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.statusPalAddon)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusPalCurrent)).BeginInit();
			this.palMain.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItem1,
																					 this.menuItem5,
																					 this.menuItem13,
																					 this.menuItem11,
																					 this.menuItem7,
																					 this.menuItem10,
																					 this.menuItem9});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuOpen,
																					  this.mnuSave,
																					  this.mnuSaveGif,
																					  this.mnuSettings,
																					  this.menuItem3,
																					  this.mnuExit});
			this.menuItem1.Text = "File";
			// 
			// mnuOpen
			// 
			this.mnuOpen.Index = 0;
			this.mnuOpen.Text = "Open";
			this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
			// 
			// mnuSave
			// 
			this.mnuSave.Index = 1;
			this.mnuSave.Text = "Save to JPG";
			this.mnuSave.Click += new System.EventHandler(this.mnuSave_Click);
			// 
			// mnuSaveGif
			// 
			this.mnuSaveGif.Index = 2;
			this.mnuSaveGif.Text = "Save to GIF";
			this.mnuSaveGif.Click += new System.EventHandler(this.mnuSaveGif_Click);
			// 
			// mnuSettings
			// 
			this.mnuSettings.Index = 3;
			this.mnuSettings.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.mnuBackgroundColor});
			this.mnuSettings.Text = "Settings";
			// 
			// mnuBackgroundColor
			// 
			this.mnuBackgroundColor.Index = 0;
			this.mnuBackgroundColor.Text = "Background Color";
			this.mnuBackgroundColor.Click += new System.EventHandler(this.mnuBackgroundColor_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 4;
			this.menuItem3.Text = "-";
			// 
			// mnuExit
			// 
			this.mnuExit.Index = 5;
			this.mnuExit.Text = "Exit";
			this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuReset,
																					  this.menuItem4,
																					  this.mnuResize,
																					  this.mnuRotate,
																					  this.mnuFlip,
																					  this.mnuCrop,
																					  this.mnuCanvas,
																					  this.menuScale});
			this.menuItem5.Text = "Image";
			// 
			// mnuReset
			// 
			this.mnuReset.Enabled = false;
			this.mnuReset.Index = 0;
			this.mnuReset.Text = "Reset";
			this.mnuReset.Click += new System.EventHandler(this.mnuReset_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 1;
			this.menuItem4.Text = "-";
			// 
			// mnuResize
			// 
			this.mnuResize.Index = 2;
			this.mnuResize.Text = "Resize";
			this.mnuResize.Click += new System.EventHandler(this.mnuResize_Click);
			// 
			// mnuRotate
			// 
			this.mnuRotate.Index = 3;
			this.mnuRotate.Text = "Rotate";
			this.mnuRotate.Click += new System.EventHandler(this.mnuRotate_Click);
			// 
			// mnuFlip
			// 
			this.mnuFlip.Index = 4;
			this.mnuFlip.Text = "Flip";
			this.mnuFlip.Click += new System.EventHandler(this.mnuFlip_Click);
			// 
			// mnuCrop
			// 
			this.mnuCrop.Index = 5;
			this.mnuCrop.Text = "Crop";
			this.mnuCrop.Click += new System.EventHandler(this.mnuCrop_Click);
			// 
			// mnuCanvas
			// 
			this.mnuCanvas.Index = 6;
			this.mnuCanvas.Text = "Canvas Size";
			this.mnuCanvas.Click += new System.EventHandler(this.mnuCanvas_Click);
			// 
			// menuScale
			// 
			this.menuScale.Index = 7;
			this.menuScale.Text = "Scale";
			this.menuScale.Click += new System.EventHandler(this.menuScale_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuAdjust,
																					   this.menuItem2,
																					   this.mnuTransparent,
																					   this.mnuGray,
																					   this.mnuGrey,
																					   this.mnuInvert,
																					   this.mnuSepia,
																					   this.mnuBlackWhite,
																					   this.mnuBright,
																					   this.mnuContrast,
																					   this.mnuGamma});
			this.menuItem13.Text = "Adjust";
			// 
			// mnuAdjust
			// 
			this.mnuAdjust.Index = 0;
			this.mnuAdjust.Text = "Color Adjust";
			this.mnuAdjust.Click += new System.EventHandler(this.mnuAdjust_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "-";
			// 
			// mnuTransparent
			// 
			this.mnuTransparent.Index = 2;
			this.mnuTransparent.Text = "Tranparent";
			this.mnuTransparent.Click += new System.EventHandler(this.mnuTransparent_Click);
			// 
			// mnuGray
			// 
			this.mnuGray.Index = 3;
			this.mnuGray.Text = "GrayScale";
			this.mnuGray.Click += new System.EventHandler(this.mnuGray_Click);
			// 
			// mnuGrey
			// 
			this.mnuGrey.Index = 4;
			this.mnuGrey.Text = "Grey";
			this.mnuGrey.Click += new System.EventHandler(this.mnuGrey_Click);
			// 
			// mnuInvert
			// 
			this.mnuInvert.Index = 5;
			this.mnuInvert.Text = "Invert";
			this.mnuInvert.Click += new System.EventHandler(this.mnuInvert_Click);
			// 
			// mnuSepia
			// 
			this.mnuSepia.Index = 6;
			this.mnuSepia.Text = "Sepia";
			this.mnuSepia.Click += new System.EventHandler(this.mnuSepia_Click);
			// 
			// mnuBlackWhite
			// 
			this.mnuBlackWhite.Index = 7;
			this.mnuBlackWhite.Text = "BlackWhite";
			this.mnuBlackWhite.Click += new System.EventHandler(this.mnuBlackWhite_Click);
			// 
			// mnuBright
			// 
			this.mnuBright.Index = 8;
			this.mnuBright.Text = "Brightness";
			this.mnuBright.Click += new System.EventHandler(this.mnuBright_Click);
			// 
			// mnuContrast
			// 
			this.mnuContrast.Index = 9;
			this.mnuContrast.Text = "Contrast";
			this.mnuContrast.Click += new System.EventHandler(this.mnuContrast_Click);
			// 
			// mnuGamma
			// 
			this.mnuGamma.Index = 10;
			this.mnuGamma.Text = "Gamma";
			this.mnuGamma.Click += new System.EventHandler(this.mnuGamma_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 3;
			this.menuItem11.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuBlurGroup,
																					   this.mnuSharpenGroup,
																					   this.mnuDistortGroup,
																					   this.mnuStylizeGroup,
																					   this.menuItem6,
																					   this.mnuEdgeDetection,
																					   this.menuItem8,
																					   this.mnuFeather});
			this.menuItem11.Text = "Filter";
			// 
			// mnuBlurGroup
			// 
			this.mnuBlurGroup.Index = 0;
			this.mnuBlurGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.mnuBlur,
																						 this.mnuSmooth});
			this.mnuBlurGroup.Text = "Blur";
			// 
			// mnuBlur
			// 
			this.mnuBlur.Index = 0;
			this.mnuBlur.Text = "Gaussian Blur";
			this.mnuBlur.Click += new System.EventHandler(this.mnuBlur_Click);
			// 
			// mnuSmooth
			// 
			this.mnuSmooth.Index = 1;
			this.mnuSmooth.Text = "Smooth";
			this.mnuSmooth.Click += new System.EventHandler(this.mnuSmooth_Click);
			// 
			// mnuSharpenGroup
			// 
			this.mnuSharpenGroup.Index = 1;
			this.mnuSharpenGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.mnuSharpen,
																							this.mnuMeanRemoval});
			this.mnuSharpenGroup.Text = "Sharpen";
			// 
			// mnuSharpen
			// 
			this.mnuSharpen.Index = 0;
			this.mnuSharpen.Text = "Sharpen";
			this.mnuSharpen.Click += new System.EventHandler(this.mnuSharpen_Click);
			// 
			// mnuMeanRemoval
			// 
			this.mnuMeanRemoval.Index = 1;
			this.mnuMeanRemoval.Text = "MeanRemoval";
			this.mnuMeanRemoval.Click += new System.EventHandler(this.mnuMeanRemoval_Click);
			// 
			// mnuDistortGroup
			// 
			this.mnuDistortGroup.Index = 2;
			this.mnuDistortGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.mnuDiffuse,
																							this.mnuDither,
																							this.mnuDitherVertical});
			this.mnuDistortGroup.Text = "Distort";
			// 
			// mnuDiffuse
			// 
			this.mnuDiffuse.Index = 0;
			this.mnuDiffuse.Text = "Diffuse";
			this.mnuDiffuse.Click += new System.EventHandler(this.mnuDiffuse_Click);
			// 
			// mnuDither
			// 
			this.mnuDither.Index = 1;
			this.mnuDither.Text = "DitherHorizontal";
			this.mnuDither.Click += new System.EventHandler(this.mnuDither_Click);
			// 
			// mnuDitherVertical
			// 
			this.mnuDitherVertical.Index = 2;
			this.mnuDitherVertical.Text = "DitherVertical";
			this.mnuDitherVertical.Click += new System.EventHandler(this.mnuDitherVertical_Click);
			// 
			// mnuStylizeGroup
			// 
			this.mnuStylizeGroup.Index = 3;
			this.mnuStylizeGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.mnuEmboss,
																							this.mnuEngrave,
																							this.mnuGlassBorder,
																							this.mnuWater});
			this.mnuStylizeGroup.Text = "Stylize";
			// 
			// mnuEmboss
			// 
			this.mnuEmboss.Index = 0;
			this.mnuEmboss.Text = "Emboss";
			this.mnuEmboss.Click += new System.EventHandler(this.mnuEmboss_Click);
			// 
			// mnuEngrave
			// 
			this.mnuEngrave.Index = 1;
			this.mnuEngrave.Text = "Engrave";
			this.mnuEngrave.Click += new System.EventHandler(this.mnuEngrave_Click);
			// 
			// mnuGlassBorder
			// 
			this.mnuGlassBorder.Index = 2;
			this.mnuGlassBorder.Text = "GlassBorder";
			this.mnuGlassBorder.Click += new System.EventHandler(this.mnuGlassBorder_Click);
			// 
			// mnuWater
			// 
			this.mnuWater.Index = 3;
			this.mnuWater.Text = "Water";
			this.mnuWater.Click += new System.EventHandler(this.mnuWater_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 4;
			this.menuItem6.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuEDSobel,
																					  this.mnuEDPrewiit,
																					  this.mnuEDKirsh,
																					  this.EDHorizontal,
																					  this.mnuEDVertical,
																					  this.mnuEDDifference,
																					  this.mnuEDHomogenity,
																					  this.mnuEDEnhance});
			this.menuItem6.Text = "EdgeDetection";
			// 
			// mnuEDSobel
			// 
			this.mnuEDSobel.Index = 0;
			this.mnuEDSobel.Text = "EdgeDetectSobel";
			this.mnuEDSobel.Click += new System.EventHandler(this.mnuEDSobel_Click);
			// 
			// mnuEDPrewiit
			// 
			this.mnuEDPrewiit.Index = 1;
			this.mnuEDPrewiit.Text = "EdgeDetectPrewitt";
			this.mnuEDPrewiit.Click += new System.EventHandler(this.mnuEDPrewiit_Click);
			// 
			// mnuEDKirsh
			// 
			this.mnuEDKirsh.Index = 2;
			this.mnuEDKirsh.Text = "EdgeDetectKirsh";
			this.mnuEDKirsh.Click += new System.EventHandler(this.mnuEDKirsh_Click);
			// 
			// EDHorizontal
			// 
			this.EDHorizontal.Index = 3;
			this.EDHorizontal.Text = "EdgeDetectHorizontal";
			this.EDHorizontal.Click += new System.EventHandler(this.EDHorizontal_Click);
			// 
			// mnuEDVertical
			// 
			this.mnuEDVertical.Index = 4;
			this.mnuEDVertical.Text = "EdgeDetectVertical";
			this.mnuEDVertical.Click += new System.EventHandler(this.mnuEDVertical_Click);
			// 
			// mnuEDDifference
			// 
			this.mnuEDDifference.Index = 5;
			this.mnuEDDifference.Text = "EdgeDetectDifference";
			this.mnuEDDifference.Click += new System.EventHandler(this.mnuEDDifference_Click);
			// 
			// mnuEDHomogenity
			// 
			this.mnuEDHomogenity.Index = 6;
			this.mnuEDHomogenity.Text = "EdgeDetectHomogenity";
			this.mnuEDHomogenity.Click += new System.EventHandler(this.mnuEDHomogenity_Click);
			// 
			// mnuEDEnhance
			// 
			this.mnuEDEnhance.Index = 7;
			this.mnuEDEnhance.Text = "EdgeEnhance";
			this.mnuEDEnhance.Click += new System.EventHandler(this.mnuEDEnhance_Click);
			// 
			// mnuEdgeDetection
			// 
			this.mnuEdgeDetection.Index = 5;
			this.mnuEdgeDetection.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.mnuMosaicNormal,
																							 this.mnuMosaicGrid});
			this.mnuEdgeDetection.Text = "Mosaic";
			// 
			// mnuMosaicNormal
			// 
			this.mnuMosaicNormal.Index = 0;
			this.mnuMosaicNormal.Text = "Normal";
			this.mnuMosaicNormal.Click += new System.EventHandler(this.mnuMosaicNormal_Click);
			// 
			// mnuMosaicGrid
			// 
			this.mnuMosaicGrid.Index = 1;
			this.mnuMosaicGrid.Text = "Grid";
			this.mnuMosaicGrid.Click += new System.EventHandler(this.mnuMosaicGrid_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 6;
			this.menuItem8.Text = "-";
			// 
			// mnuFeather
			// 
			this.mnuFeather.Index = 7;
			this.mnuFeather.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuFeather1,
																					   this.mnuFeather2,
																					   this.menuItem12,
																					   this.mnuFeather3});
			this.mnuFeather.Text = "Feather";
			// 
			// mnuFeather1
			// 
			this.mnuFeather1.Index = 0;
			this.mnuFeather1.Text = "Do Feather with Selected Rectangle";
			this.mnuFeather1.Click += new System.EventHandler(this.mnuFeather1_Click);
			// 
			// mnuFeather2
			// 
			this.mnuFeather2.Index = 1;
			this.mnuFeather2.Text = "Frame with a Feather Way";
			this.mnuFeather2.Click += new System.EventHandler(this.mnuFeather2_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 2;
			this.menuItem12.Text = "-";
			// 
			// mnuFeather3
			// 
			this.mnuFeather3.Index = 3;
			this.mnuFeather3.Text = "Configurate Feather Builder";
			this.mnuFeather3.Click += new System.EventHandler(this.mnuFeather3_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 4;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuSetBorder});
			this.menuItem7.Text = "Border";
			// 
			// mnuSetBorder
			// 
			this.mnuSetBorder.Index = 0;
			this.mnuSetBorder.Text = "Set Border";
			this.mnuSetBorder.Click += new System.EventHandler(this.mnuSetBorder_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 5;
			this.menuItem10.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuAbout});
			this.menuItem10.Text = "Help";
			// 
			// mnuAbout
			// 
			this.mnuAbout.Index = 0;
			this.mnuAbout.Text = "About";
			this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
			// 
			// toolBar
			// 
			this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.tbOpen,
																					   this.tbSave,
																					   this.tbReset,
																					   this.toolBarButton1,
																					   this.tbCrop,
																					   this.tbResize,
																					   this.tbRotate,
																					   this.tbFlip,
																					   this.toolBarButton3,
																					   this.tbColorAdjust,
																					   this.toolBarButton4});
			this.toolBar.DropDownArrows = true;
			this.toolBar.ImageList = this.imgList;
			this.toolBar.Location = new System.Drawing.Point(0, 0);
			this.toolBar.Name = "toolBar";
			this.toolBar.ShowToolTips = true;
			this.toolBar.Size = new System.Drawing.Size(656, 59);
			this.toolBar.TabIndex = 0;
			this.toolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_ButtonClick);
			// 
			// tbOpen
			// 
			this.tbOpen.ImageIndex = 0;
			this.tbOpen.Text = "Open";
			this.tbOpen.ToolTipText = "Open the photo file";
			// 
			// tbSave
			// 
			this.tbSave.ImageIndex = 1;
			this.tbSave.Text = "Save";
			this.tbSave.ToolTipText = "Save the edited photo";
			// 
			// tbReset
			// 
			this.tbReset.ImageIndex = 7;
			this.tbReset.Text = "Reset";
			this.tbReset.ToolTipText = "Reset";
			// 
			// toolBarButton1
			// 
			this.toolBarButton1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbCrop
			// 
			this.tbCrop.ImageIndex = 5;
			this.tbCrop.Text = "Crop";
			this.tbCrop.ToolTipText = "Crop the photo";
			// 
			// tbResize
			// 
			this.tbResize.ImageIndex = 6;
			this.tbResize.Text = "Resize";
			this.tbResize.ToolTipText = "Resize";
			// 
			// tbRotate
			// 
			this.tbRotate.ImageIndex = 3;
			this.tbRotate.Text = "Rotate";
			this.tbRotate.ToolTipText = "Rotate";
			// 
			// tbFlip
			// 
			this.tbFlip.ImageIndex = 4;
			this.tbFlip.Text = "Flip";
			this.tbFlip.ToolTipText = "Flip";
			// 
			// toolBarButton3
			// 
			this.toolBarButton3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbColorAdjust
			// 
			this.tbColorAdjust.ImageIndex = 8;
			this.tbColorAdjust.Text = "ColorAdjust";
			this.tbColorAdjust.ToolTipText = "ColorAdjust";
			// 
			// toolBarButton4
			// 
			this.toolBarButton4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// imgList
			// 
			this.imgList.ImageSize = new System.Drawing.Size(32, 32);
			this.imgList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgList.ImageStream")));
			this.imgList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 439);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.statusPalAddon,
																						 this.statusPalCurrent});
			this.statusBar.ShowPanels = true;
			this.statusBar.Size = new System.Drawing.Size(656, 22);
			this.statusBar.SizingGrip = false;
			this.statusBar.TabIndex = 1;
			// 
			// statusPalAddon
			// 
			this.statusPalAddon.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusPalAddon.Width = 646;
			// 
			// statusPalCurrent
			// 
			this.statusPalCurrent.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.statusPalCurrent.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusPalCurrent.Width = 10;
			// 
			// palMain
			// 
			this.palMain.AutoScroll = true;
			this.palMain.BackColor = System.Drawing.Color.Black;
			this.palMain.Controls.Add(this.pic);
			this.palMain.Cursor = System.Windows.Forms.Cursors.Default;
			this.palMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.palMain.Location = new System.Drawing.Point(0, 59);
			this.palMain.Name = "palMain";
			this.palMain.Size = new System.Drawing.Size(656, 380);
			this.palMain.TabIndex = 2;
			// 
			// pic
			// 
			this.pic.BackColor = System.Drawing.Color.Transparent;
			this.pic.Location = new System.Drawing.Point(0, 0);
			this.pic.Name = "pic";
			this.pic.Size = new System.Drawing.Size(656, 383);
			this.pic.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pic.TabIndex = 0;
			this.pic.TabStop = false;
			this.pic.SizeChanged += new System.EventHandler(this.pic_SizeChanged);
			this.pic.Paint += new System.Windows.Forms.PaintEventHandler(this.pic_Paint);
			this.pic.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pic_MouseUp);
			this.pic.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pic_MouseMove);
			this.pic.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pic_MouseDown);
			// 
			// dlgFile
			// 
			this.dlgFile.DefaultExt = "*.JPEG;*.JPG;*.BMP;*.GIF;*.TIF;*.TIFF";
			this.dlgFile.Filter = "Image Files(*.JPEG;*.JPG;*.BMP;*.GIF;*.TIF;*.TIFF)|*.JPEG;*.JPG;*.BMP;*.GIF;*.TIF" +
				";*.TIFF)|All Files(*.*)|*.*";
			// 
			// dlgSave
			// 
			this.dlgSave.DefaultExt = "*.jpg";
			this.dlgSave.Filter = "Jpeg File(*.JPEG;*.JPG)|*.JPEG;*.JPG";
			// 
			// dlgColor
			// 
			this.dlgColor.AnyColor = true;
			this.dlgColor.Color = System.Drawing.Color.Transparent;
			this.dlgColor.FullOpen = true;
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 6;
			this.menuItem9.Text = "test";
			this.menuItem9.Click += new System.EventHandler(this.menuItem9_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.AutoScroll = true;
			this.AutoScrollMinSize = new System.Drawing.Size(10, 10);
			this.ClientSize = new System.Drawing.Size(656, 461);
			this.Controls.Add(this.palMain);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.toolBar);
			this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "frmMain";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "PhotoGear";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.Load += new System.EventHandler(this.Form2_Load);
			((System.ComponentModel.ISupportInitialize)(this.statusPalAddon)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusPalCurrent)).EndInit();
			this.palMain.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		protected void setReset(bool enable) 
		{
			mnuReset.Enabled = enable;
			tbReset.Enabled = enable;
		}

		protected void setSave(bool enable)
		{
			tbSave.Enabled = enable;
			mnuSave.Enabled = enable;
		}

		protected void setRefresh(bool enable)
		{
			pic.Refresh();
			Modified=enable;
			setReset(enable);
			//setSave(enable);
		}

		private void Form2_Load(object sender, System.EventArgs e)
		{
			setReset(false);
		}

		private void mnuOpen_Click(object sender, System.EventArgs e)
		{
			dlgFile.ShowDialog();
			if (dlgFile.FileName!="") 
			{
				palMain.AutoScroll = false;
				FileName=dlgFile.FileName;
				pic.Image=System.Drawing.Image.FromFile(FileName,true);
				this.statusPalCurrent.Text = "Current Image:" + pic.Image.Width.ToString() + "X" + pic.Image.Height.ToString() + "X" + pic.Image.PixelFormat.ToString();
				this.statusPalAddon.Text ="";
				pic_SizeChanged(sender,e);
			}
		}

		private void mnuResize_Click(object sender, System.EventArgs e)
		{
			if (FileName=="" || pic.Image ==null) return;

			// creates the ResizeForm
			frmResize fResize = new frmResize();

			// initialize the ResizeForm component values
			fResize.txtHeight.Value = pic.Image.Height;
			fResize.txtWidth.Value = pic.Image.Width;

			// if user click OK button, then resize
			if (fResize.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new angGoGo.PhotoController.Controller(pic.Image);

				// new feature in 1.2 
				pc.InterpolationMode = (InterpolationMode)fResize.cboxIMode.SelectedIndex;

				pic.Image = pc.Resize(fResize.NewWidth,fResize.NewHeight);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void menuScale_Click(object sender, System.EventArgs e)
		{
			if (FileName=="" || pic.Image ==null) return;

			angGoGo.PhotoController.Controller pc = new angGoGo.PhotoController.Controller(pic.Image);
			pic.Image = pc.Scale(320,320);
			pc.Dispose();
			setRefresh(true);
		}

		private void toolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button==this.tbOpen)
				mnuOpen_Click(sender,e);

			if (e.Button == this.tbResize)
				mnuResize_Click(sender,e);

			if (e.Button == this.tbReset)
				mnuReset_Click(sender,e);

			if (e.Button==this.tbRotate)
				mnuRotate_Click(sender,e);

			if (e.Button == this.tbFlip)
				mnuFlip_Click(sender,e);

			if (e.Button == this.tbSave)
				mnuSave_Click(sender,e);

			if (e.Button == this.tbCrop)
				mnuCrop_Click(sender,e);

			if (e.Button == this.tbColorAdjust)
				mnuAdjust_Click(sender,e);
		}

		private void mnuReset_Click(object sender, System.EventArgs e)
		{
			if (FileName.Trim()=="") return;
			pic.Image = Image.FromFile(FileName);
			setRefresh(false);
		}

		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (Modified) 
				if (Helper.Ask("Do you want to save the image?"))
				{
					this.mnuSave_Click(sender,e);
				}

		}

		private void mnuRotate_Click(object sender, System.EventArgs e)
		{
			if (FileName=="" || pic.Image ==null) return;
			frmRotate fRotate = new frmRotate();
			fRotate.MyParentForm = this;
			if (fRotate.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc =new angGoGo.PhotoController.Controller(pic.Image);
				pic.Image = pc.Rotate((float)Convert.ToDouble(fRotate.txtAngle.Text),Color.FromName(fRotate.cboxBackColor.Text));
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuFlip_Click(object sender, System.EventArgs e)
		{
			if (FileName=="" || pic.Image ==null) return;
			frmFlip fFlip = new frmFlip();
			fFlip.myParentForm = this;
			if (fFlip.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc =new angGoGo.PhotoController.Controller(pic.Image);
				pic.Image = pc.Flip(fFlip.flipflag);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void pic_SizeChanged(object sender, System.EventArgs e)
		{
			if (pic.Image ==null) return;
			palMain.AutoScroll = true;

			if (pic.Image.Width >= palMain.Width )
				pic.Left = 0;
			else
				pic.Left  = palMain.Width / 2 - pic.Image.Width / 2;

			if (pic.Image.Height >= palMain.Height) 
				pic.Top = 0;
			else
				pic.Top = palMain.Height /2 - pic.Image.Height /2;
		}

		private void mnuSave_Click(object sender, System.EventArgs e)
		{
			uint iQuality = 75;
			frmConfigJpeg fConfigJpeg = new frmConfigJpeg();
			if (fConfigJpeg.ShowDialog() == DialogResult.OK) 
			{
				iQuality = (uint)fConfigJpeg.trackBar1.Value;
			
				dlgSave.FileName = FileName;
				dlgSave.Filter = "Jpeg File(*.JPEG;*.JPG)|*.JPEG;*.JPG";
				dlgSave.DefaultExt = "*.jpg";
				if (dlgSave.ShowDialog()==DialogResult.OK) 
				{
					angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
					string SaveFileName = dlgSave.FileName;
					pc.Save(SaveFileName,CompressionType.CompressionNone,iQuality,PhotoFormat.Jpeg);
					pc.Dispose();
				}
			}
		}

		private void mnuSaveGif_Click(object sender, System.EventArgs e)
		{
			uint iQuality = 256;
			frmSaveGif fSaveGif = new frmSaveGif();
			if (fSaveGif.ShowDialog() == DialogResult.OK) 
			{
				iQuality = (uint)fSaveGif.barColor.Value;
				bool transparent = fSaveGif.chkTransparent.Checked;
				CompressionType ct = angGoGo.PhotoController.CompressionType.GifStandard256;
				if (fSaveGif.comboBox1.SelectedIndex==0)
					ct = CompressionType.GifAdaptive;
				else if (fSaveGif.comboBox1.SelectedIndex == 1)
					ct = CompressionType.GifOctreeQuantizer;
				else if (fSaveGif.comboBox1.SelectedIndex == 2)
					ct = CompressionType.GifStandard256;
				else if (fSaveGif.comboBox1.SelectedIndex == 3)
					ct = CompressionType.GifWebSafe;

				dlgSave.FileName = FileName;
				dlgSave.Filter = "Gif File(*.GIF)|*.gif";
				dlgSave.DefaultExt = "*.jpg";
				if (dlgSave.ShowDialog()==DialogResult.OK) 
				{
					angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
					string SaveFileName = dlgSave.FileName;
					pc.Save(SaveFileName,ct,iQuality,PhotoFormat.Gif,transparent);

					pc.Dispose();
				}
			}
		}


		private void mnuCrop_Click(object sender, System.EventArgs e)
		{
			if (ptBeg.X == 0 && ptBeg.Y==0 && ptEnd.X==0 && ptEnd.Y==0)
			{
				Helper.ShowError("Please select a region on the image firstly!");
			}
			else if (FileName!="" && pic.Image != null)
			{
				angGoGo.PhotoController.Controller pc =new angGoGo.PhotoController.Controller(pic.Image);
				pic.Image = pc.Crop(ptBeg,ptEnd);
				pc.Dispose();
				setRefresh(true);
			}
		}

		#region Draw a rectangle on the picture
		// this part is very simple, just draw an ugly rectangle on the picture

		// return a rectangle according to start point and end point
		private Rectangle Rect(Point ptBeg,Point ptEnd)
		{
			return new Rectangle(Math.Min(ptBeg.X,ptEnd.Y),
				Math.Min(ptBeg.Y,ptEnd.Y),
				Math.Abs(ptEnd.X - ptBeg.X),
				Math.Abs(ptEnd.Y - ptBeg.Y));
		}

		private void pic_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				ptBeg = ptEnd = new Point(e.X,e.Y);

				Graphics gx = pic.CreateGraphics();
				gx.DrawRectangle(new Pen(ForeColor),Rect(ptBeg,ptEnd));
				gx.Dispose();
				bBlocking =true;
				this.statusPalAddon.Text = "";
			}
		}

		private void pic_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (bBlocking && (e.Button & MouseButtons.Left)!=0)
			{
				Graphics gx=pic.CreateGraphics();

				gx.DrawRectangle(new Pen(BackColor),Rect(ptBeg,ptEnd));
				ptEnd=new Point(e.X,e.Y);
				gx.DrawRectangle(new Pen(ForeColor),Rect(ptBeg,ptEnd));
				gx.Dispose();
				pic.Invalidate();

				this.statusPalAddon.Text = "CropX1=" + ptBeg.X.ToString() + ";"
					+ "CropY1=" + ptBeg.Y.ToString() + ";" 
					+ "CropX2=" + ptEnd.X.ToString() + ";" 
					+ "CropY2=" + ptEnd.Y.ToString();

			}
		}

		private void pic_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (bBlocking)
			{
				Graphics gx=pic.CreateGraphics();
				rectBox = Rect(ptBeg,new Point(e.X,e.Y));
				gx.DrawRectangle(new Pen(ForeColor),rectBox);
				gx.Dispose();

				bBlocking=false;
			}
		}

		#endregion

		private void pic_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if (bBlocking)
			{
				Graphics gx=e.Graphics;
				gx.DrawRectangle(new Pen(ForeColor),Rect(ptBeg,ptEnd));
			}
			if (pic.Image!=null)
				this.statusPalCurrent.Text = "Current Image:" + pic.Image.Width.ToString() + "X" + pic.Image.Height.ToString() + "X" + pic.Image.PixelFormat.ToString();
		}

		private void mnuAbout_Click(object sender, System.EventArgs e)
		{
			new frmAbout().ShowDialog();
		}

		private void mnuAdjust_Click(object sender, System.EventArgs e)
		{
			if (FileName=="" || pic.Image == null) return;
			if (dlgColor.ShowDialog()==DialogResult.OK)
			{
				angGoGo.PhotoController.Controller pc = new angGoGo.PhotoController.Controller(pic.Image);
				pic.Image = pc.ColorAdjust(dlgColor.Color);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuTransparent_Click(object sender, System.EventArgs e)
		{
			if (FileName=="" || pic.Image ==null) return;
			frmOpacity fOpacity=new frmOpacity();
			fOpacity.MyParentForm = this;
			if (fOpacity.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc =new angGoGo.PhotoController.Controller(pic.Image);
				pic.Image = pc.Transparent((sbyte)fOpacity.trackOpacity.Value);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuBackgroundColor_Click(object sender, System.EventArgs e)
		{
			if (dlgColor.ShowDialog()==DialogResult.OK) 
			{
				palMain.BackColor = dlgColor.Color;
				pic.BackColor = dlgColor.Color;
			}
		}

		private void mnuInvert_Click(object sender, System.EventArgs e)
		{
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			pic.Image = pc.ColorAdjust(AdjustType.Invert);
			pc.Dispose();
			setRefresh(true);
		}

		private void mnuGray_Click(object sender, System.EventArgs e)
		{
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			pic.Image = pc.ColorAdjust(AdjustType.GrayScale);
			pc.Dispose();
			setRefresh(true);
		}

		private void mnuGrey_Click(object sender, System.EventArgs e)
		{
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			pic.Image = pc.ColorAdjust(AdjustType.Grey);
			pc.Dispose();
			setRefresh(true);
		}

		private void mnuBright_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Brightness Adjust";
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				pic.Image = pc.SetBrightness((sbyte)fParam.trackLevel.Value);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuBlackWhite_Click(object sender, System.EventArgs e)
		{
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			pic.Image = pc.ColorAdjust(AdjustType.BlackWhite);
			pc.Dispose();
			setRefresh(true);
		}

		private void mnuSepia_Click(object sender, System.EventArgs e)
		{
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			pic.Image = pc.ColorAdjust(AdjustType.Sepia);
			pc.Dispose();
			setRefresh(true);
		}

		private void mnuContrast_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Contrast Adjust";
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				pic.Image = pc.SetContrast((sbyte)fParam.trackLevel.Value);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuGamma_Click(object sender, System.EventArgs e)
		{
			frmGamma fGamma=new frmGamma();
			if (fGamma.ShowDialog()==DialogResult.OK)
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				pic.Image = pc.SetGamma( (double)fGamma.trackRed.Value/10,
					(double)fGamma.trackGreen.Value/10,
					(double)fGamma.trackBlue.Value/10);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuSmooth_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Smooth Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 50;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Smooth);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuBlur_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "GaussianBlur Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 50;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.GaussianBlur);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuSharpen_Click(object sender, System.EventArgs e)
		{
			//Sharpen need a level between 0 and 40
			frmParam fParam=new frmParam();
			fParam.Text = "Sharpen Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 40;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Sharpen);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuMeanRemoval_Click(object sender, System.EventArgs e)
		{
			//MeanRemval need a level between 0 and 40
			frmParam fParam=new frmParam();
			fParam.Text = "MeanRemoval Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 50;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.MeanRemoval);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuEmboss_Click(object sender, System.EventArgs e)
		{
			//emboss need a level between 0 and 5
			frmParam fParam=new frmParam();
			fParam.Text = "Emboss Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 5;
			fParam.trackLevel.SmallChange=1;fParam.trackLevel.TickFrequency=1;fParam.trackLevel.LargeChange=1;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Emboss);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuEngrave_Click(object sender, System.EventArgs e)
		{
			//engrave doesn't need a level value
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Engrave);
			pic.Image = pc.Filter(filters);
			pc.Dispose();
			setRefresh(true);
		}

		private void mnuEDSobel_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "EdgeDetect Sobel Level";
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectSobel);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuEDPrewiit_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "EdgeDetect Prewitt Level";
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectPrewitt);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuEDKirsh_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "EdgeDetect Kirsh Level";
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectKirsh);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void EDHorizontal_Click(object sender, System.EventArgs e)
		{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectHorizontal);
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
		}

		private void mnuEDVertical_Click(object sender, System.EventArgs e)
		{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectHorizontal);
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
		}

		private void mnuEDDifference_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "EdgeDetect Difference Level";
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectDifference);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuEDHomogenity_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "EdgeDetect Homogenity Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 255;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeDetectHomogenity);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuEDEnhance_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Edge Enhance Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 255;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.EdgeEnhance);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuMosaicNormal_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Mosaic Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 100;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Mosaic);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuMosaicGrid_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Mosaic grid Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 100;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.MosaicGrid);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}


		private void mnuDiffuse_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Diffuse Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 100;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Diffuse);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuDither_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "DitherHorizontal Level";
			fParam.trackLevel.Minimum =0;fParam.trackLevel.Maximum = 200;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.DitherHorizontal);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuCanvas_Click(object sender, System.EventArgs e)
		{
			frmCanvas fCanvas = new frmCanvas();
			fCanvas.lbeHeight.Text = fCanvas.txtHeight.Text = pic.Image.Height.ToString();
			fCanvas.lbeWidth.Text  = fCanvas.txtWidth.Text = pic.Image.Width.ToString();
			if (fCanvas.ShowDialog()==DialogResult.OK)
			{
				angGoGo.PhotoController.Controller pc= new Controller(pic.Image);
				angGoGo.PhotoController.AnchorType anchor = (AnchorType)fCanvas.cboxAnchor.SelectedIndex;
				pic.Image = pc.CanvasSize(int.Parse(fCanvas.txtWidth.Text),int.Parse(fCanvas.txtHeight.Text),anchor,Color.White);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuDitherVertical_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "DitherVertical Level";
			fParam.trackLevel.Minimum =0;fParam.trackLevel.Maximum = 200;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.DitherVertical);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuGlassBorder_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "GlassVessel Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 255;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.GlassBorder);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuWater_Click(object sender, System.EventArgs e)
		{
			frmParam fParam=new frmParam();
			fParam.Text = "Water Level";
			fParam.trackLevel.Minimum = 0;fParam.trackLevel.Maximum = 50;
			if (fParam.ShowDialog()==DialogResult.OK) 
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.Filters filters=new Filters(FilterStyle.Water);
				filters.Level = fParam.trackLevel.Value;
				pic.Image = pc.Filter(filters);
				pc.Dispose();
				setRefresh(true);
			}
		}

		private void mnuSetBorder_Click(object sender, System.EventArgs e)
		{
			frmBorder fBorder=new frmBorder();
			if (fBorder.ShowDialog()==DialogResult.OK)
			{
				angGoGo.PhotoController.Controller pc =new Controller(pic.Image);
				angGoGo.PhotoController.Borders borders = new Borders((PhotoBorderStyle)fBorder.cboxBorderStyle.SelectedIndex);

				borders.Length = fBorder.trackLength.Value;

				//borders.PhotoBorderStyle = PhotoBorderStyle.Customize;
				//borders.Brush = new SolidBrush(Color.Black);
				borders.CenterColor = fBorder.btColor.BackColor;
				pic.Image = pc.SetBorder(borders);
				pc.Dispose();
				setRefresh(true);
			}
		}

		#region Feather functions
		//below are feather related functions
		//FEATHER function is very strong, so I can't show all of them in here.
		//I will consider to write a forum online to let all users to discuss it


		// This is the easiest way to feather the image with selected rectangle
		// In fact, I am too lazy to write code to draw other shapes on the picture,
		// Feather fucntion can work with kinds of shape.
		// If you write the code to draw any shape on the picture, could you 
		// mail to me so that I could integrate into this program
		//
		// 1. select a background for feather
		// 2. create a featherbuilder object, assign the background color (default is black)
		// 3. build a rectangle mask, this function will use the rectangle size that is drawn on the image
		// 4. call feather function
		private void mnuFeather1_Click(object sender, System.EventArgs e)
		{
			if (dlgColor.ShowDialog()==DialogResult.OK)
			{
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.FeatherBuilder builder = new FeatherBuilder(pic.Image.Width,pic.Image.Height);
				builder.BackgroundColor = dlgColor.Color ;
				builder.BuildRectangleMask(Rect(ptBeg,ptEnd));
				pic.Image = pc.Feather(builder);
				pc.Dispose();
				builder.Dispose();
				setRefresh(true);
			}
		}

		// This function demostrate how to frame in a feather way
		// PhotoController could specify a tile bitmap as background
		// after feathering, the specialized tile bitmap will replace other places except the selected region
		//
		// I specify 25 as a frame width, change that value if you like
		//
		// This 
		private void mnuFeather2_Click(object sender, System.EventArgs e)
		{
			angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
			angGoGo.PhotoController.FeatherBuilder builder = new FeatherBuilder(pic.Image.Width,pic.Image.Height);

			// tell builder to use bitmap as background
			builder.BackgroundStyle = angGoGo.PhotoController.FeatherBackgroundStyle.UseBitmap;
			
			string currentfolder = System.IO.Path.GetDirectoryName(Application.ExecutablePath);
			builder.LoadTileBitmap(currentfolder + "\\BackgroundTexture1.bmp");

			// IMPORATNT
			// set band to be a small value.
			// if you set this too large, the picture will be feathered too much
			builder.Band = 2;

			// create a rectangle that is 25 smaller than picture
			// the width 25 will be replaced by tile bitmap
			Rectangle rect = new Rectangle(25,25, pic.Image.Width - 50, pic.Image.Height - 50);
			builder.BuildRectangleMask(rect);

			// this border style might not be similar to a frame shadow, you could try others
			angGoGo.PhotoController.Borders border = new Borders(PhotoBorderStyle.Customize);
			border.Brush = new SolidBrush(Color.Gray);

			// because the feather background will occupy 25 width, the border width here must be larger than 25 so that
			// it could be seen and have a frame feeling
			border.Length = 27;
			// write border firstly to have a shadow feeling
			pc.SetBorder(border);

			// after writing a border, then feather myself to have a similar frame feeling
			pic.Image = pc.Feather(builder);
			pc.Dispose();
			builder.Dispose();
			setRefresh(true);
		}

		// This function demostrates how to feather in different shapes
		// to have a best effect, I recommend to use a large image
		// because the mask size is hardcode here.

		private void mnuFeather3_Click(object sender, System.EventArgs e)
		{
			if (pic.Image == null)
			{
				MessageBox.Show("Please load an image firstly.");
				return;
			}

			if (pic.Image.Width <300 && pic.Image.Height < 300)
			{
				MessageBox.Show("Please load a large size picture to get a best effect.");
				return;
			}

			frmFeather fFeather = new frmFeather();
			if (fFeather.ShowDialog() == DialogResult.OK)
			{
				int band = fFeather.trackBand.Value;
				Color backgroundcolor = fFeather.btColor.BackColor;
				int width = pic.Image.Width;
				int height = pic.Image.Height;

				//initialize PhotoController and FeatherBuilder
				angGoGo.PhotoController.Controller pc = new Controller(pic.Image);
				angGoGo.PhotoController.FeatherBuilder builder = new FeatherBuilder(width,height);

				//default background color is black
				//you must set this value if you want to specify it
				builder.BackgroundColor = backgroundcolor;

				//default feather band is 16
				//you must set this value is you want to specify it
				builder.Band = band;

				switch (fFeather.cboxStyle.SelectedIndex)
				{
					case 0: // create an ellipse mask
					{
						Rectangle rect = new Rectangle(band + 20, band + 20, width - (band + 20) * 2, height - (band+20) * 2);
						builder.BuildEllipseMask(rect);
						break;
					}
					case 1: // create a mask like a door with graphicpah
					{
						GraphicsPath path = new GraphicsPath();
						path.AddEllipse(50, 50, width - 50 - band*2 , 200);
						path.AddRectangle(new Rectangle (50,150, width - 50 - band * 2, height - 150 - band * 2));
						builder.BuildPathMask(path);						
						break;
					}
					case 2: // create rectangles mask
					{
						RectangleF[] rects ={
												new RectangleF(  50.0F,   50.0F, (float)(width - 100), 200.0F),
												new RectangleF(100.0F, 200.0F, 250.0F,  150.0F),
												new RectangleF(200.0F, 250.0F, 180.0F, height - 300.0f)
											};
						builder.BuildRectanglesMask(rects);
						break;
					}
					case 3: // create a casual closed curve
					{
						PointF point1 = new PointF(width/2, 50 + band * 2);
						PointF point2 = new PointF(width*3/4, height/4);
						PointF point3 = new PointF(width*7/8, height/2);
						PointF point4 = new PointF(width*3/4, height-100 - band*2);
						PointF point5 = new PointF(width/4, height-100 - band*2);
						PointF point6 = new PointF(width/8, height/2);

						PointF[] points = {point1, point2, point3, point4, point5, point6};

						//the second parameter is FillMode
						//the third parameter is tension, do not set too large, otherwise the shape will be very strange
						//you could find this parameter's meaning in MSDN
						builder.BuildClosedCurveMask(points,FillMode.Winding,1.0f);
						break;
					}
					case 4: // create a casual polygon
					{
						PointF point1 = new PointF(width/2, 50 + band * 2);
						PointF point2 = new PointF(width*3/4, height/4);
						PointF point3 = new PointF(width*7/8, height/2);
						PointF point4 = new PointF(width*3/4, height-100 - band*2);
						PointF point5 = new PointF(width/4, height-100 - band*2);
						PointF point6 = new PointF(width/8, height/2);

						PointF[] points = {point1, point2, point3, point4, point5, point6};

						builder.BuildPolygonMask(points);
						break;
					}
				}

				pic.Image = pc.Feather(builder);
				pc.Dispose();
				builder.Dispose();
				setRefresh(true);
			}
		}

		#endregion

		private void menuItem9_Click(object sender, System.EventArgs e)
		{
			Bitmap bm = new Bitmap("C:\\1.jpg");
			Controller objpc = new Controller(bm);
			bm.Dispose();
			objpc.Resize(0.5f);
			objpc.Save("c:\\1.jpg");
			objpc.Dispose();
			
		}


	}
}
