using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PhotoControllerDemo
{
	/// <summary>
	/// Summary description for frmToolForm.
	/// </summary>
	public class frmOpacity : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btCancel;
		private System.Windows.Forms.Button btOK;
		private System.Windows.Forms.GroupBox gPreview;
		private System.Windows.Forms.PictureBox picPreview;
		public System.Windows.Forms.TrackBar trackOpacity;
		public frmMain MyParentForm;
		private System.Windows.Forms.Label lbeOpacity;
		private System.ComponentModel.Container components = null;


		public frmOpacity()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btCancel = new System.Windows.Forms.Button();
			this.btOK = new System.Windows.Forms.Button();
			this.gPreview = new System.Windows.Forms.GroupBox();
			this.picPreview = new System.Windows.Forms.PictureBox();
			this.trackOpacity = new System.Windows.Forms.TrackBar();
			this.lbeOpacity = new System.Windows.Forms.Label();
			this.gPreview.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackOpacity)).BeginInit();
			this.SuspendLayout();
			// 
			// btCancel
			// 
			this.btCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btCancel.Location = new System.Drawing.Point(120, 256);
			this.btCancel.Name = "btCancel";
			this.btCancel.Size = new System.Drawing.Size(80, 24);
			this.btCancel.TabIndex = 7;
			this.btCancel.Text = "Cancel";
			// 
			// btOK
			// 
			this.btOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btOK.Location = new System.Drawing.Point(16, 256);
			this.btOK.Name = "btOK";
			this.btOK.Size = new System.Drawing.Size(80, 24);
			this.btOK.TabIndex = 6;
			this.btOK.Text = "OK";
			// 
			// gPreview
			// 
			this.gPreview.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.picPreview});
			this.gPreview.Location = new System.Drawing.Point(16, 96);
			this.gPreview.Name = "gPreview";
			this.gPreview.Size = new System.Drawing.Size(184, 144);
			this.gPreview.TabIndex = 8;
			this.gPreview.TabStop = false;
			this.gPreview.Text = "Preview";
			// 
			// picPreview
			// 
			this.picPreview.Dock = System.Windows.Forms.DockStyle.Fill;
			this.picPreview.Location = new System.Drawing.Point(3, 17);
			this.picPreview.Name = "picPreview";
			this.picPreview.Size = new System.Drawing.Size(178, 124);
			this.picPreview.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.picPreview.TabIndex = 0;
			this.picPreview.TabStop = false;
			// 
			// trackOpacity
			// 
			this.trackOpacity.Location = new System.Drawing.Point(8, 40);
			this.trackOpacity.Maximum = 100;
			this.trackOpacity.Name = "trackOpacity";
			this.trackOpacity.Size = new System.Drawing.Size(192, 42);
			this.trackOpacity.TabIndex = 9;
			this.trackOpacity.TickFrequency = 10;
			this.trackOpacity.Value = 100;
			this.trackOpacity.Scroll += new System.EventHandler(this.trackOpacity_Scroll);
			// 
			// lbeOpacity
			// 
			this.lbeOpacity.AutoSize = true;
			this.lbeOpacity.Location = new System.Drawing.Point(16, 13);
			this.lbeOpacity.Name = "lbeOpacity";
			this.lbeOpacity.Size = new System.Drawing.Size(89, 14);
			this.lbeOpacity.TabIndex = 10;
			this.lbeOpacity.Text = "Opacity - 100%";
			// 
			// frmToolForm
			// 
			this.AcceptButton = this.btOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.CancelButton = this.btCancel;
			this.ClientSize = new System.Drawing.Size(218, 290);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lbeOpacity,
																		  this.trackOpacity,
																		  this.gPreview,
																		  this.btCancel,
																		  this.btOK});
			this.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "frmToolForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "frmOpacity";
			this.Load += new System.EventHandler(this.frmToolForm_Load);
			this.gPreview.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackOpacity)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void LoadPreviewPic(bool Refresh) 
		{
			Image image = ((frmMain)MyParentForm).pic.Image;
			
			if (image.Width > gPreview.Width || image.Height > gPreview.Height) 
			{
				angGoGo.PhotoController.Controller pc = new angGoGo.PhotoController.Controller(image);
				picPreview.Image = pc.Scale(gPreview.Width,gPreview.Height);				
				pc.Dispose();
				if (Refresh)
					picPreview.Refresh();
			}
			else 
				picPreview.Image = image;
		}

		private void frmToolForm_Load(object sender, System.EventArgs e)
		{
			LoadPreviewPic(true);
		}

		private void trackOpacity_Scroll(object sender, System.EventArgs e)
		{
			LoadPreviewPic(false);
			int opacity=trackOpacity.Value;
			lbeOpacity.Text = "Opacity - " + opacity.ToString() + "%";
			angGoGo.PhotoController.Controller pc= new angGoGo.PhotoController.Controller(picPreview.Image);
			picPreview.Image = pc.Transparent((sbyte)opacity);
			pc.Dispose();
		}
	}
}
